#if defined _knife_arena_included
	#endinput
#endif
#define _knife_arena_included

//	https://world-source.ru/hueco_mundo/knife_arena_config.zip

enum KA_Reason
{
	KA_Disconnect = 0,	// Вышел с сервера.
	KA_Box,				// Не на арене (не в клетке).
	KA_Team,			// Сменил команду.
	KA_Suicide,			// Убил сам себя .
	KA_Death,			// Умер (т.к. урон наносится лишь от соперника, значит его убил соперник).
	KA_Self,			// Покинул арену сам (через меню).
	KA_Admin,			// Удалён админом.
	KA_RoundEnd,		// Раунд завершён.
	KA_RoundRestart		// mp_restartgame.
};

enum KA_Event
{
	KA_OnArenaSpawn = 0,
	KA_OnArenaSpawnPost,
	
	KA_OnPushToQueue,
	KA_OnPushToQueuePost,
	
	KA_OnPushFromQueueToArena,
	KA_OnPushFromQueueToArenaPost,
	
	KA_OnArenaTimer,
	KA_OnArenaHasWinner,
	KA_OnLeaveArena,
	KA_OnArenaClientRemoved,
	KA_OnFightTimerEnd,
	KA_OnPickedUpRestrictedWeapon
};

typeset KA_CB
{
	//	KA_OnArenaSpawn
	//	Арена вот-вот будет создана. Plugin_Continue = создать, Plugin_Stop = не создавать.
	function Action ();
	
	//	KA_OnArenaSpawnPost
	function void (const float center[3], const float tt[3], const float ct[3]);
	
	/////
	
	//	KA_OnPushToQueue
	//	Игрок хочет занять очередь на арену. Plugin_Continue = разрешить, Plugin_Stop = запретить.
	function Action (int client);
	
	//	KA_OnPushToQueuePost
	function void (int client, int queue, int place);
	
	/////
	
	//	KA_OnPushFromQueueToArena
	//	Пришла очередь игрока. Plugin_Stop = запретить = из очереди берётся следующий игрок.
	function Action (int client);
	
	//	KA_OnPushFromQueueToArenaPost
	function void (int client);
	
	/////
	
	//	KA_OnArenaTimer
	//	Отсчет перед поединком (0 = go).
	function void (int sec);
	
	//	KA_OnArenaHasWinner
	//	Игрок winner УБИЛ игрока loser.
	function void (int winner, int loser);
	
	//	KA_OnLeaveArena
	//	Игрок хочет покинуть арену (через меню).
	function Action (int client);
	
	//	KA_OnArenaClientRemoved
	//	Игрок покинул арену.
	function void (int client, KA_Reason reason);
	
	//	KA_OnFightTimerEnd
	//	Время поединка истекло (ConVar ka_timer_fight) и оба игрока были убиты.
	function void (int tt, int ct);
	
	//	KA_OnPickedUpRestrictedWeapon
	//	Plugin_Continue = разрешить подбор запрещённого на арене оружия (sWeapon без weapon_).
	function Action (int client, const char[] sWeapon);
}

native void KA_HookEvent(KA_Event event, KA_CB callback);

native bool KA_ClientOnArena(int client);					// Игрок на арене?
native bool KA_ArenaExists();								// Арена создана ?
native bool KA_ArenaExistsAndReady();						// Арена создана и доступна?
native bool KA_IsArena(const float vec[3]);					// Координаты внутри арены ?
native bool KA_RemoveFromQueue(int client);					// Удалить игрока из очереди.
native bool KA_RemoveFromArena(int client);					// Удалить игрока с арены.
native bool KA_PushToQueue(int client);						// Добавить игрока в конец очереди.
native bool KA_DeleteArena();								// Удалить арену. В следующем раунде появится снова.

native void KA_GetArenaClients(int &t, int &ct);			// Получить игроков на арене . Если < 1, то игрока нет на арене.
native void KA_GetPlaceInQueue(int client, int &queue = 0);	// Получить позицию в очереди. Если < 1, то нет в очереди. queue = общее кол-во товарищей в очереди, с учётом client игрока.

public SharedPlugin __pl_knife_arena = 
{
	name = "knife_arena",
	file = "knife_arena.smx",
#if defined REQUIRE_PLUGIN
	required = 1,
#else
	required = 0,
#endif
};

#if !defined REQUIRE_PLUGIN
public void __pl_knife_arena_SetNTVOptional()
{
	MarkNativeAsOptional("KA_HookEvent");
	MarkNativeAsOptional("KA_ClientOnArena");
	MarkNativeAsOptional("KA_ArenaExists");
	MarkNativeAsOptional("KA_ArenaExistsAndReady");
	MarkNativeAsOptional("KA_IsArena");
	MarkNativeAsOptional("KA_RemoveFromQueue");
	MarkNativeAsOptional("KA_RemoveFromArena");
	MarkNativeAsOptional("KA_PushToQueue");
	MarkNativeAsOptional("KA_DeleteArena");
	MarkNativeAsOptional("KA_GetArenaClients");
	MarkNativeAsOptional("KA_GetPlaceInQueue");
}
#endif